      *****************************************************************
      * VERSION:     1.1
      * COPYRIGHT:
      *
      *   (C) COPYRIGHT International Business Machines Corp. 1993, 1997
      *   All Rights Reserved
      *   Licensed Materials - Property of IBM
      *
      *   US Government Users Restricted Rights - Use, duplication or
      *   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
      *
      *   This program has been modified to be pseudo-conversational by
      *    Jim MacNair - March, 1998
      *
      *   As part of this modification, a new copybook named USRBRWS
      *    was created, to reflect the user COMMAREA.
      *
      *****************************************************************
      *****************************************************************
      *    DFHCBRW - CICS SAMPLE FILEA BROWSE - COBOL                 *
      *****************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID. NEWCBRW.
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       77  I        PIC 999   USAGE IS COMP.
      * 77  MESSAGES PIC X(39) VALUE ' '.
       01  MESSAGES.
           02 JUNK PIC X(39) VALUE ' '.
           02  FILLER REDEFINES JUNK.
            03 FILLER PIC X(23).
            03 RESPCODE PIC 9(8).
            03 FNCODE   PIC 9(8).
       77  STATS    PIC X(1)  VALUE ' '.
      *                                          DATA-AREAS FOR RIDFLD
      * The following statement was changed to fix a bug in the
      * original program, and replaced with the two statements that
      * follow.
      *77  RID      PIC 9(6)  VALUE IS ZERO.
       01  RID      PIC 9(6)  VALUE IS ZERO.
       01  RIDX     REDEFINES RID PIC X(6).
      *                                          BUILDS PREV BACK PAGE
      *                                          BMS STD ATTRIBUTES
                    COPY DFHBMSCA.
      *                                          FILEA RECORD DESCRIPT'N
       01  FILEA.   COPY DFHCFIL.
      *                                          GENERAL MENU MAP
                    COPY DFHAID.
      *                                          GENERAL MENU MAP
      * COMMAREA ADDED TO MAKE PROGRAM PSEUDO-CONVERSATIONAL
       01  CA.
           COPY USRBRWS.
      *
      * USER COMMAREA ADDED TO MAKE PROGRAM PSEUDO-CONVERSATIONAL
       LINKAGE SECTION.
       01  DFHCOMMAREA.
           COPY STDHEAD.
           02  USRCOMM.
      * Insert User COMMAREA, TCTUA, BMS MAPS HERE

           COPY USRBRWS.
      *
                    COPY EFHCGA.
      *                                          BROWSE FILEA MAP
                    COPY EFHCGC.
      *
       PROCEDURE DIVISION.
           EXEC CICS HANDLE CONDITION
                            ERROR(ERRORS)
                            NOTFND(NOTFOUND) END-EXEC.
      * STATEMENTS INSERTED TO CONVERT TO PSEUDO-CONVERSATIONAL
      * IF EIBCALEN IS ZERO, THEN THIS IS THE FIRST PASS,
      * OTHERWISE, THIS IS A LATER PASS.
           IF USRCALEN = 0 THEN
      *
      *        EXEC CICS RECEIVE MAP('MENU') MAPSET('DFHCGA')
      *        END-EXEC
               IF 'MENU' IS NOT EQUAL TO USRMAPNAME
                   GO TO BADMAPNAME
               END-IF
           ELSE
               MOVE USRCOMM OF DFHCOMMAREA TO CA
      *
      *        EXEC CICS HANDLE AID
      *                         CLEAR(SMSG)
      *                         PF1 (PAGE-FORWARD)
      *                         PF2 (PAGE-BACKWARD)
      *                         END-EXEC
      *
      * DEFAULT TO PAGE-FORWARD IF NOT USER INPUT
      *
               EXEC CICS HANDLE CONDITION
                                MAPFAIL (PAGE-FORWARD)
                                END-EXEC
      *
      *        EXEC CICS RECEIVE MAP('BROWSE') MAPSET('DFHCGC')
      *        END-EXEC
               IF 'BROWSE' IS NOT EQUAL TO USRMAPNAME
                   GO TO BADMAPNAME
               END-IF
               IF USRAID IS EQUAL TO DFHCLEAR
                   GO TO SMSG
               END-IF
               IF USRAID IS EQUAL TO DFHPF1
                   GO TO PAGE-FORWARD
               END-IF
               IF USRAID IS EQUAL TO DFHPF2
                   GO TO PAGE-BACKWARD
               END-IF
               IF USRMAPLN IS EQUAL TO 0
                   GO TO PAGE-FORWARD
               END-IF
               GO TO START-BRW
           END-IF

      *****************************************************************
      *                                SIMPLE CHECKS OF INPUT DATA    *
      *****************************************************************
           IF KEYL NOT = ZERO THEN
              IF KEYI IS NUMERIC THEN
      *                                                  VALID INPUT
                 MOVE KEYI TO RID
                 MOVE KEYI TO RIDF OF CA
                 MOVE KEYI TO RIDB OF CA
              ELSE
      *                                                  NOT NUMERIC
                 MOVE
                 'ACCOUNT NUMBER MUST BE NUMERIC'
                 TO MESSAGES
                 GO TO MENU
           ELSE
      *                                              ACCOUNT NO OMITTED
              MOVE '000000' TO RID
              MOVE '000000' TO RIDF OF CA.
      * The following statement was added to fix a bug in the
      * original program.  The NOTFND condition was being raised
      * if a key of 999999 was used.  The key of 999999 is supposed
      * to start browsing backwards from the end of the file.
           IF RID IS EQUAL TO '999999' THEN
               MOVE HIGH-VALUES TO RIDX.
      *
      * The following statement was changed to fix a bug in the
      * original program.
      *    IF RID NOT EQUAL '999999' THEN GO TO PAGE-FORWARD.
           IF RIDX NOT EQUAL HIGH-VALUES THEN GO TO PAGE-FORWARD.
      *
           MOVE 'H' TO STATS.
           MOVE RID TO RIDB OF CA.
           GO TO PAGE-BACKWARD.
      * INSERTED PARAGRAPH TO CONVERT TO PSEUDO-CONVERSATIONAL
       START-BRW.
           IF DIRI = 'B' THEN
               MOVE 'B' TO DIRI
           ELSE
               MOVE 'F' TO DIRI.
           MOVE DIRI TO CURROP OF CA.
           IF CURROP OF CA = 'F'
               MOVE RIDF OF CA TO RID
           ELSE
               MOVE RIDB OF CA TO RID.
           IF CURROP OF CA = 'B'
               GO TO PAGE-BACKWARD.
      * END OF INSERTION
      *****************************************************************
      *                                BUILD NEXT FORWARD PAGE        *
      *****************************************************************
       PAGE-FORWARD.
           MOVE 'F' TO CURROP OF CA.
      *                                                  TOP END OF FILE
           EXEC CICS HANDLE CONDITION
                            ENDFILE(TOOHIGH) END-EXEC.
      *                                                  RESET MAP 'C'
           MOVE LOW-VALUES TO BROWSEO.
      *                                                  RID>NEXT FPAGE
           MOVE RIDF OF CA TO RID.
           MOVE 1 TO I.
      *****************************************************************
      *                                ESTABLISH START POINT          *
      *****************************************************************
           EXEC CICS STARTBR DATASET('FILEA')
                             RIDFLD(RID) END-EXEC.
      *
       NEXT-LINE.
      *                                                  MOVE FIELDS>MAP
           EXEC CICS READNEXT INTO(FILEA)
                              DATASET('FILEA')
                              RIDFLD(RID) END-EXEC.
      *                                                  READ 4 RECORDS
           IF I = 1 THEN
              MOVE NUMB TO NUMBER1O
              MOVE NAMEX TO NAME1O
              MOVE AMOUNT TO AMOUNT1O
      *                                          RIDB NEEDS EXISTING A/C
              MOVE RID TO RIDB OF CA
           ELSE IF I = 2 THEN
                   MOVE NUMB TO NUMBER2O
                   MOVE NAMEX TO NAME2O
                   MOVE AMOUNT TO AMOUNT2O
                ELSE IF I = 3 THEN
                        MOVE NUMB TO NUMBER3O
                        MOVE NAMEX TO NAME3O
                        MOVE AMOUNT TO AMOUNT3O
                     ELSE IF I = 4 THEN
                        MOVE NUMB TO NUMBER4O
                        MOVE NAMEX TO NAME4O
                        MOVE AMOUNT TO AMOUNT4O.
           ADD 1 TO I.
           IF I NOT EQUAL 5 THEN GO TO NEXT-LINE.
      *                                                  RID>NEXT FPAGE
           MOVE RID TO RIDF OF CA.
      *    EXEC CICS SEND MAP('BROWSE') MAPSET('DFHCGC')
      *              ERASE END-EXEC.
           MOVE 'E' TO ERASESW.
           MOVE 'BROWSE' TO USRMAPNAME.
           MOVE 'DFHCGC' TO USRMAPSET.
      *                                                  GET NEXT RQUEST
           GO TO PROMPT-ENTRY.
      *****************************************************************
      *                                BUILD PREVIOUS BACK PAGE       *
      *****************************************************************
       PAGE-BACKWARD.
           MOVE 'B' TO CURROP OF CA.
      *                                                  RESET MAP 'C'
           MOVE LOW-VALUES TO BROWSEO.
      *                                                  RID>PREV BPAGE
           MOVE RIDB OF CA TO RID.
      *                                                  RIDF>NEXT FPAGE
           MOVE RIDB OF CA TO RIDF OF CA.
      *                                                  LOW END OF FILE
           EXEC CICS HANDLE CONDITION
                            ENDFILE(TOOLOW) END-EXEC.
      *****************************************************************
      *                                ESTABLISH START POINT          *
      *****************************************************************
           EXEC CICS STARTBR DATASET('FILEA')
                             RIDFLD(RID) END-EXEC.
      *
           IF LASTOP OF CA EQUAL 'B' THEN GO TO PREV.
           IF STATS EQUAL 'H' THEN GO TO PREV.
      *
           EXEC CICS READPREV INTO(FILEA)
                              DATASET('FILEA')
                              RIDFLD(RID) END-EXEC.
      *
       PREV.
           MOVE 1 TO I.
      *
       PREV-LINE.
      *                                                  MOVE FIELDS>MAP
           EXEC CICS READPREV INTO(FILEA)
                              DATASET('FILEA')
                              RIDFLD(RID) END-EXEC.
      *                                                READ 4 RECORDS IN
      *                                                DESCENDING ORDER
           IF I = 4 THEN
              MOVE NUMB TO NUMBER1O
              MOVE NAMEX TO NAME1O
              MOVE AMOUNT TO AMOUNT1O
           ELSE IF I = 3 THEN
                   MOVE NUMB TO NUMBER2O
                   MOVE NAMEX TO NAME2O
                   MOVE AMOUNT TO AMOUNT2O
                ELSE IF I = 2 THEN
                        MOVE NUMB TO NUMBER3O
                        MOVE NAMEX TO NAME3O
                        MOVE AMOUNT TO AMOUNT3O
                     ELSE IF I = 1 THEN
                        MOVE NUMB TO NUMBER4O
                        MOVE NAMEX TO NAME4O
                        MOVE AMOUNT TO AMOUNT4O.
      *
           ADD 1 TO I.
           IF I NOT EQUAL 5 THEN GO TO PREV-LINE.
      *                                                  RID>NEXT BPAGE
           MOVE RID TO RIDB OF CA.
      *    EXEC CICS SEND MAP('BROWSE') MAPSET('DFHCGC')
      *              ERASE END-EXEC.
           MOVE 'E' TO ERASESW.
           MOVE 'BROWSE' TO USRMAPNAME.
           MOVE 'DFHCGC' TO USRMAPSET.
      *                                                  GET NEXT RQUEST
           GO TO PROMPT-ENTRY.
      *****************************************************************
      *                                 PROMPT FOR NEXT PAGING REQUEST*
      *****************************************************************
       PROMPT-ENTRY.
           MOVE CURROP OF CA TO LASTOP OF CA.
      * INSERTED CICS RETURN TO MAKE PROGRAM PSEUDO-CONVERSATOINAL
      *     EXEC CICS RETURN TRANSID('BRWS') COMMAREA(CA)
      *          LENGTH(LENGTH OF CA) END-EXEC.
            MOVE 'BRWS' TO NXTRNID
            MOVE CA TO USRCOMM OF DFHCOMMAREA
            MOVE LENGTH OF CA TO USRCALEN
            EXEC CICS RETURN END-EXEC.
      * END OF INSERTION
      *    EXEC CICS RECEIVE MAP('BROWSE') MAPSET('DFHCGC') END-EXEC.
      *    IF DIRI EQUAL 'F' THEN GO TO PAGE-FORWARD.
      *    IF DIRI EQUAL 'B' THEN GO TO PAGE-BACKWARD.
      *                                                  INVALID-RESEND
      *    EXEC CICS SEND MAP('BROWSE') MAPSET('DFHCGC') END-EXEC.
      *    GO TO PROMPT-ENTRY.
      *****************************************************************
      *                                HANDLE END OF FILE CONDITIONS  *
      *****************************************************************
       TOOHIGH.
           MOVE 'H' TO STATS.
           MOVE RID TO RIDF OF CA.
           MOVE RID TO RIDB OF CA.
           MOVE ' ' TO DIRO.
           MOVE 'HI-END OF FILE' TO MSG1O.
      *                                                  BRT+PROT ATTR
           MOVE DFHBMASB TO MSG1A.
      *    EXEC CICS SEND MAP('BROWSE') MAPSET('DFHCGC')
      *              ERASE END-EXEC.
           MOVE 'E' TO ERASESW.
           MOVE 'BROWSE' TO USRMAPNAME.
           MOVE 'DFHCGC' TO USRMAPSET.
           GO TO PROMPT-ENTRY.
      *
       TOOLOW.
           MOVE 'L' TO STATS.
           MOVE '000000' TO RIDF OF CA.
           MOVE '000000' TO RIDB OF CA.
           MOVE ' ' TO DIRO.
           MOVE 'LO-END OF FILE' TO MSG2O.
      *                                                  BRT+PROT ATTR
           MOVE DFHBMASB TO MSG2A.
      *    EXEC CICS SEND MAP('BROWSE') MAPSET('DFHCGC')
      *              ERASE END-EXEC.
           MOVE 'E' TO ERASESW.
           MOVE 'BROWSE' TO USRMAPNAME.
           MOVE 'DFHCGC' TO USRMAPSET.
           GO TO PROMPT-ENTRY.
      *****************************************************************
      *                                HANDLE GENERAL CONDITIONS      *
      *****************************************************************
       NOTFOUND.
           MOVE 'END OF FILE - PLEASE RESTART' TO MESSAGES.
           GO TO MENU.
       SMSG.
           MOVE 'PRESS CLEAR TO EXIT' TO MESSAGES.
           GO TO MENU.
       ERRORS.
           EXEC CICS DUMP DUMPCODE('ERRS') END-EXEC.
           MOVE 'TRANSACTION TERMINATED' TO MESSAGES.
           MOVE EIBRCODE TO RESPCODE.
           MOVE EIBFN TO FNCODE.
           EXEC CICS WRITE OPERATOR
                TEXT(MESSAGES) TEXTLENGTH(39)
           END-EXEC.
      *****************************************************************
      *                                DISPLAY GENERAL MENU THEN EXIT *
      *****************************************************************
       MENU.
      *                                                  RESET MAP 'A'
           MOVE LOW-VALUE TO MENUO.
           MOVE DFHBMASB TO MSGA.
           MOVE MESSAGES TO MSGO.
      *    EXEC CICS SEND MAP('MENU') MAPSET('DFHCGA')
      *              ERASE END-EXEC.
           MOVE 'E' TO ERASESW.
           MOVE 'MENU' TO USRMAPNAME.
           MOVE 'DFHCGA' TO USRMAPSET.
      *    EXEC CICS RETURN END-EXEC.
           MOVE ZEROS TO USRCALEN
           EXEC CICS RETURN END-EXEC.
           GOBACK.
       BADMAPNAME.
           MOVE 'MAP NAME DOES NOT MATCH' TO TEXTAREA.
           MOVE 'SENDTEXT' TO USRMAPNAME.
           MOVE ZEROS TO USRCALEN.
           EXEC CICS RETURN END-EXEC.
